﻿using System;
using System.Collections.Generic;

namespace otszaz
{
    class Termek
    {
        public int Db { get; set; }
        public string Nev { get; set; }

        public Termek(string nev)
        {
            Db = 1;
            Nev = nev;
        }

        public static Termek operator ++ (Termek i)
        {
           i.Db++;
            return i;
        }

        public int ertek()
        {
            if (Db == 1)
            {
                return 500;
            }
            if (Db == 2)
            {
                return 950;
            }
            return 950 + (Db - 2) * 400;
        }

        public void Kiir()
        {
            Console.WriteLine(Db + " " + Nev);
        }
    }
    class Kosar
    {
        public int ID { get; private set; }
        public List<Termek> Termekek { get; set; }

        public Kosar(int i)
        {
            ID = i;
            Termekek = new List<Termek>();
        }

        public void Betesz(string termek)
        {
            int j = 0;
            while (j< Termekek.Count && Termekek[j].Nev != termek)
            {
                j++;
            }
            if (j<Termekek.Count)
            {
                Termekek[j]++;
            }
            else
            {
                Termekek.Add(new Termek(termek));
            }
        }

        public int Szum()
        {
            int szum = 0;
            foreach (Termek aru in Termekek)
            {
                szum += aru.ertek();
            }
            return szum;
        }

        public int Darab()
        {
            int db = 0;
            foreach (Termek aru in Termekek)
            {
                db += aru.Db;
            }
            return db;
        }

        public bool Van(string termek)
        {
            int i = 0;
            while (i<Termekek.Count && Termekek[i].Nev != termek)
            {
                i++;
            }
            return (i < Termekek.Count);
        }
    }



    class Program
    {
        static List<Kosar> kosarak = new List<Kosar>();
        static void Main(string[] args)
        {
            //1. feladat - beolvasás
            Input();
            Console.WriteLine("2. feladat");
            Console.WriteLine("A fizetések száma: {0}", kosarak.Count);
            Console.WriteLine("3. feladat");
            Console.WriteLine("Az első vásárló {0} darab árucikket vásárolt.", kosarak[0].Darab());
            Console.WriteLine("4. feladat");
            Console.Write("Adja meg egy vásárlás sorszámát! ");
            int sorszam = Convert.ToInt32(Console.ReadLine());
            Console.Write("Adja meg egy árucikk nevét! ");
            string cikk = Console.ReadLine();
            Console.Write("Adja meg a vásárolt darabszámot! ");
            int darab = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine("5. feladat");
            Console.WriteLine("Az első vásárlás sorszáma: {0}", Elso(cikk) + 1);
            Console.WriteLine("Az utolsó vásárlás sorszáma: {0}", Utolso(cikk) + 1);
            Console.WriteLine("{0} vásárlás során vettek belőle.", Vettek(cikk, Elso(cikk), Utolso(cikk)));

            Console.WriteLine("6. feladat");       
            Console.WriteLine("{0} darab vételekor fizetendő {1}", darab, ertek(darab) );

            Console.WriteLine("7. feladat");
            for (int i = 0; i < kosarak[sorszam - 1].Termekek.Count; i++)
            {
                kosarak[sorszam - 1].Termekek[i].Kiir();
            }
            //8. feladat - fájlba írás
            Output();

            Console.ReadKey();
           
        }

        private static int ertek(int darab)
        {
            //a fgv ujraírása helyett egy fiktiv termék értéke 
            Termek egytermek = new Termek("");
            egytermek.Db = darab;
            return egytermek.ertek();
        }

        private static void Input()
        {
            using (System.IO.StreamReader sr = new System.IO.StreamReader("penztar.txt"))
            {
                int i = 0;
                while (!sr.EndOfStream)
                {
                    i++;
                    Kosar kosar = new Kosar(i);
                    string termek = sr.ReadLine();
                    while (termek != "F")
                    {
                        kosar.Betesz(termek);
                        termek = sr.ReadLine();
                    }
                    kosarak.Add(kosar);
                }
            }
        }

        private static int Elso(string cikk)
        {
            int i = 0;
            while (!kosarak[i].Van(cikk))
            {
                i++;
            }
            return i;
        }

        private static int Utolso(string cikk)
        {
            int i = kosarak.Count - 1;
            while (!kosarak[i].Van(cikk))
            {
                i--;
            }
            return i;
        }

        private static int Vettek(string cikk, int elso, int utolso)
        {
            int db = 0;
            for (int i = elso; i <= utolso; i++)
            {
                if (kosarak[i].Van(cikk))
                {
                    db++;
                }
            }
            return db;
        }

        private static void Output()
        {
            using (System.IO.StreamWriter sw = new System.IO.StreamWriter("osszeg.txt"))
            {
                for (int i = 0; i < kosarak.Count; i++)
                {
                    sw.WriteLine(kosarak[i].ID + ": " + kosarak[i].Szum());
                }
            }
        }
    }
}
